// FF2048
`timescale 1 ns/100 ps
module rtax2000_cq352_FF2048 (D, Q, CLK, RST, ANDP, ORP, ANDC, ORC);

input D, CLK, RST;
output Q, ANDP, ORP, ANDC, ORC;



wire [5:1] Q_w[5:1];

wire [5:1] andp[5:1];
wire [5:1] orp[5:1];

wire [5:1] andc[5:1];
wire [5:1] orc[5:1];


wire [5:1] ANDP_int;
wire [5:1] ORP_int;
wire [5:1] ANDC_int;
wire [5:1] ORC_int;



//wire [5:1] ANDP_sig;
//wire [5:1] ORP_sig;
//wire [5:1] ANDC_sig;
//wire [5:1] ORC_sig;

assign Q_w [1][1] = D;
assign Q= Q_w [4][5];


//assign ANDP = ANDP_int [4];
//assign ORP = ORP_int [4];
//assign ANDC = ANDC_int [4];
//assign ORC = ORC_int [4];


	generate
		genvar i,j;
				for (j = 1; j <=4; j= j+1)
					begin: Combinational_FF2048
						for (i = 1; i <=4; i= i+1)
							begin: Combinational_FF32
								FF8 FF8_inst1(.D(Q_w[j][i]), .Q(Q_w[j][i+1]), .CLK(CLK), .RST(RST), .ANDP(andp[j][i]), .ORP(orp[j][i]), .ANDC(andc[j][i]), .ORC(orc[j][i]));
							end
							assign Q_w[j+1][1] = Q_w[j][5];
							AND4 and4p 	(.A(andp[j][1]), .B(andp[j][2]), .C(andp[j][3]), .D(andp[j][4]), .Y(ANDP_int[j]));
							OR4 or4p 	(.A(orp[j][1]), .B(orp[j][2]), .C(orp[j][3]), .D(orp[j][4]), .Y(ORP_int[j]));
							AND4 and4c 	(.A(andc[j][1]), .B(andc[j][2]), .C(andc[j][3]), .D(andc[j][4]), .Y(ANDC_int[j]));
							OR4 or4c 	(.A(orc[j][1]), .B(orc[j][2]), .C(orc[j][3]), .D(orc[j][4]), .Y(ORC_int[j]));					
					end

					assign ANDP = ANDP_int[4];
					assign ORP = ORP_int [4];
					assign ANDC = ANDC_int [4];
					assign ORC = ORC_int [4];

//					AND4 and4p 	(.A(ANDP_int[1]), .B(ANDP_int[2]), .C(ANDP_int[3]), .D(ANDP_int[4]), .Y(ANDP));
//					OR4 or4p 	(.A(ORP_int[1]), .B(ORP_int[2]), .C(ORP_int[3]), .D(ORP_int[4]), .Y(ORP));
//					AND4 and4c 	(.A(ANDC_int[1]), .B(ANDC_int[2]), .C(ANDC_int[3]), .D(ANDC_int[4]), .Y(ANDC));
//					OR4 or4c 	(.A(ORC_int[1]), .B(ORC_int[2]), .C(ORC_int[3]), .D(ORC_int[4]), .Y(ORC));

	endgenerate

endmodule