`timescale 1 ns/100 ps
// Version: 6.1 SP1 6.1.1.108


module rtax2000_cq352_IOs (DIO_IP, DIO_IN, DIO_O, IO_I, IO_O, DA, QA, EN8, YQ, Bi_D, Bi_E, Bi_Y, Bi_IO);

input 	[7:1] DIO_IN;
input 	[7:1] DIO_IP;
output 	[7:1] DIO_O;

input 	[7:1] Bi_D;
input 	[7:1] Bi_E;
output 	[7:1] Bi_Y;
inout 	[7:1] Bi_IO;

input  	[6:1] IO_I;
output 	[6:1] IO_O;

input  	DA;
output 	[2:0] QA;

input  	EN8;
output 	[7:0] YQ;

wire   	[6:1] IO_sig;
wire 	DA_int, DA_Buf;
wire 	EN8_int, EN8_Buf;


//LVPECL IO testing
	generate
		genvar i;
			for (i = 1; i <=7; i= i+1)
				begin: LVPECL_IOs
					  INBUF_LVPECL INBUF_LVPECL_inst(.PADP(DIO_IP[i]), .PADN(DIO_IN[i]), .Y(DIO_O[i]));
				end
	endgenerate


//Bidirectional IO testing
	generate
		genvar k;
			for (k = 1; k <=7; k= k+1)
				begin: Bid_IOs
					  BBHS  INBUF_inst(.D(Bi_D[k]), .E(Bi_E[k]), .Y(Bi_Y[k]), .PAD(Bi_IO[k]));
				end
	endgenerate


//Standard IO testing
	generate
		genvar j;
			for (j = 1; j <=6; j= j+1)
				begin: Standard_IOs
					  INBUF  INBUF_inst(.PAD(IO_I[j]), .Y(IO_sig[j]));
					  OUTBUF OUTBUF_inst(.D(IO_sig[j]), .PAD(IO_O[j]));
				end
	endgenerate

// Fanout 3

	INBUF  INBUF3_inst(.PAD(DA), .Y(DA_int));
	BUFD   BUFD3_inst(.A(DA_int), .Y(DA_Buf));
 
	generate
		genvar l;
			for (l = 0; l <=2; l= l+1)
				begin: Fanout3_IOs
					  OUTBUF OUTBUF3_inst(.D(DA_Buf), .PAD(QA[l]));
				end
	endgenerate


// Fanout 8

	INBUF  INBUF7_inst(.PAD(EN8), .Y(EN8_int));
	BUFD   BUFD7_inst(.A(EN8_int), .Y(EN8_Buf));
	generate
		genvar m;
			for (m = 0; m <=7; m= m+1)
				begin: Fanout8_IOs
					  OUTBUF OUTBUF8_inst(.D(EN8_Buf), .PAD(YQ[m]));
				end
	endgenerate
    
endmodule
