`timescale 1 ns/100 ps
module FIFO2x2048_bist(Clock, Resetn, Test_ok)/*synthesis syn_hier = "hard" */;
parameter WIDTH = 2;
input Clock, Resetn;
output Test_ok;
wire [WIDTH - 1:0] Wr_data, Rd_data;
wire AE, AF, EF, FF, AEn, AFn, EFn, FFn;
wire Reset;
assign AEn = !AE;
assign AFn = !AF;
assign FFn = !FF;
assign EFn = !EF;
assign Reset= !Resetn;

FIFO2x2048 UFIFO(.Data(Wr_data), .RE(Rdn), .WE(Wrn), .WClock(Clock), .RClock(Clock), .ACLR(Reset), 
              .FULL(FF),.AFULL(AF),.AEMPTY(AE),.EMPTY(EF), .Q(Rd_data));

testfifo #(WIDTH, 13) UTEST(.Clock(Clock), .Resetn(Resetn), 
                   .FFn(FFn), .AFn(AFn), .EFn(EFn), .AEn(AEn), .Rd_data(Rd_data),
	           .Wr_data(Wr_data), .Wrn(Wrn), .Rdn(Rdn), .Test_ok(Test_ok));
endmodule

