`timescale 1ns/100ps 
module gray_counter (clk, aclr, ena, gray_code);
 parameter SIZE = 9;
 input clk, aclr, ena;
 output [SIZE-1:0] gray_code;

 reg [SIZE-1:0] gray_code_reg;
 reg [SIZE-1:0] tog;
 integer i,j;

 assign  gray_code = gray_code_reg;

 
 always @(posedge clk or negedge aclr) 
  if (aclr==1'b0) begin
   gray_code_reg <= 0;
  end
  else begin
  if (ena==1'b1) begin
   tog = gray_code_reg;
   for (i=0; i<=SIZE-1; i=i+1) begin
    tog[i] = 1'b0;
    for (j=i; j<=SIZE-1; j=j+1) begin
     tog[i] = tog[i] ^^ gray_code_reg[j];
    end //j loop
    tog[i] = !tog[i];
    for (j=0; j<=i-1; j=j+1) begin
     tog[i] = tog[i] && !tog[j];
    end //j loop
   end //i loop
   tog[SIZE-1] = 1'b1;
   for (j=0; j<=SIZE-2; j=j+1) begin
    tog[SIZE-1] = tog[SIZE-1] && !tog[j];
   end //j loop;
   gray_code_reg <= gray_code_reg ^ tog;
  end //enabled
 end //sequential update
endmodule
