`timescale 1ns/100ps

// 8 IO Group
// Manish R. Babladi
// 03/05/2003
// 
module io_test_mon(Clock, Resetn, Io_test_ok, Io_test_mon);
parameter NUM = 31,
          WIDTH = 8;
input Clock, Resetn;
input [NUM:1] Io_test_ok;
output Io_test_mon;

wire io_mon_enable;
reg [WIDTH-1:0] io_mon;
//
// Use the reduction AND on the Io_test_ok inputs 
//  As long as all of the "ok" outputs are 1'b1 then the divider is enabled
//  and the monitor signal is output, should any of the "ok" outputs go low
//  then the mon signal will go to 1
//
assign io_mon_enable = &Io_test_ok;

always @(posedge Clock or negedge Resetn)
 if (Resetn==1'b0)
  io_mon = 0;
 else
  if (io_mon_enable==1'b1) 
   io_mon = io_mon + 1;
  else
   io_mon = -1; // All ones 

//johnson_counter #(8) UMON(.clk(Clock), .aclr(Resetn), .ena(io_mon_enable), .johnson_code(io_mon));

assign Io_test_mon = io_mon[WIDTH-1];

endmodule
