`timescale 1ns/100ps 

// Johnson Counter
// Manish R. Babladi
// 01/16/2003

module johnson_counter (clk, aclr, ena, johnson_code);

 parameter Width = 4;
 input clk, aclr, ena;
 output [Width-1:0] johnson_code;

 reg [Width-1:0] johnson_code;
 
 always @(posedge clk or negedge aclr)
	 
 begin 
  if (aclr==1'b0)
     johnson_code <= 0;
  else if (ena==1'b1 && Width > 1) 
     johnson_code <= {johnson_code[Width-2:0],!(johnson_code[Width-1])};
  else if (ena==1'b1 && Width == 1) 
     johnson_code <= ~johnson_code;
 end 
 
endmodule
