`timescale 1 ns/1 ps

// RAM combo module for AX2000
// 02/25/03 - Manish R. Babladi
//
module RAM_COMBO_TEST(Clock, Resetn, 
			Compare_ok_9x2048_1, Compare_ok_1x32768_1, 
			Compare_ok_2x2048_1, Compare_ok_4x1024_1, 
			Compare_ok_9x512_1, Compare_ok_18x512,
			Compare_ok_9x512_2, 
/*			Compare_ok_36x128,*/
			Compare_ok_9x2048_2, 
			Compare_ok_1x32768_2, Compare_ok_2x2048_2, 
			Compare_ok_4x1024_2, 
			Combo_test_ok);

input Clock, Resetn;
output Compare_ok_9x2048_1, Compare_ok_1x32768_1, Compare_ok_2x2048_1, Compare_ok_4x1024_1;
output Compare_ok_9x512_1, Compare_ok_18x512;
/*output Compare_ok_36x128;*/
output Compare_ok_9x512_2; 
output Combo_test_ok;
output Compare_ok_9x2048_2, Compare_ok_1x32768_2, Compare_ok_2x2048_2, Compare_ok_4x1024_2;

reg Combo_test_ok;

RAM9x2048_test U9x2048_1(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_9x2048_1))/* synthesis syn_noprune=1 */;
RAM1x32768_test U1x32768_1(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_1x32768_1))/* synthesis syn_noprune=1 */;
RAM2x2048_test U2x2048_1(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_2x2048_1))/* synthesis syn_noprune=1 */;
RAM4x1024_test U4x1024_1(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_4x1024_1))/* synthesis syn_noprune=1 */;
RAM9x512_test U9x512_1(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_9x512_1))/* synthesis syn_noprune=1 */;
RAM18x512_test U18x512(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_18x512))/* synthesis syn_noprune=1 */;
/*RAM36x128_test U36x128(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_36x128))|+ synthesis syn_noprune=1 +|;*/
RAM9x512_test U9x512_2(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_9x512_2))/* synthesis syn_noprune=1 */;

RAM1x32768_test U1x32768_2(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_1x32768_2))/* synthesis syn_noprune=1 */;
RAM4x1024_test U4x1024_2(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_4x1024_2))/* synthesis syn_noprune=1 */;
RAM9x2048_test U9x2048_2(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_9x2048_2))/* synthesis syn_noprune=1 */;
RAM2x2048_test U2x2048_2(.Clock(Clock), .Resetn(Resetn), .Compare_ok(Compare_ok_2x2048_2))/* synthesis syn_noprune=1 */;

always @(posedge Clock or negedge Resetn)
 if (Resetn==1'b0)
  Combo_test_ok <= 1'b1;
 else
  Combo_test_ok <= Combo_test_ok && ( (Compare_ok_9x2048_1)
                                    && (Compare_ok_1x32768_1)
                                    && (Compare_ok_2x2048_1)
                                    && (Compare_ok_4x1024_1)
                                    && (Compare_ok_9x512_1)
                                    && (Compare_ok_18x512)
/*                                    && (Compare_ok_36x128)*/
                                    && (Compare_ok_9x512_2)
				    && (Compare_ok_9x2048_2)
                                    && (Compare_ok_1x32768_2)
                                    && (Compare_ok_2x2048_2)
                                    && (Compare_ok_4x1024_2)
	                            );
endmodule

