`timescale 1 ns/100 ps

// RAMLATCH BIST MODEL
// Manish R. Babladi
// 02/03/2003

module ramlatch_bist(Clock, Resetn, Test_ok)/*synthesis syn_hier = "hard" */;

parameter DEPTH_LOG2 = 4;

input Clock, Resetn;
output Test_ok;

wire [7:0] Wr_data, Rd_data;
wire [DEPTH_LOG2 - 1:0] Rd_add;
wire [DEPTH_LOG2 - 1:0] Wr_add;
wire RD, WR; 

ramlatch uramlatch ( .Clock(Clock), .WR(WR), .RD(RD), .Radd(Rd_add), .Wadd(Wr_add), .DI(Wr_data), .Resetn(Resetn), .DO(Rd_data));


test_ramlatch uramlatchtest (.Clock(Clock), .Resetn(Resetn), .Wr(WR), .Rd(RD), .Radd(Rd_add), .Wadd(Wr_add), .Rd_data(Rd_data), .Wr_data(Wr_data), .Test_ok(Test_ok));

endmodule

