`timescale 1ns/100ps
// AX2000 Burnin module definition 
// 03/04/2003
// Manish R. Babladi
// 
// Cascaded RAM and FIFOs - 64
// IO Groups - Groups of 8
// Combo Test - Token passing
// Registers/Latches - RAM BIST
// 5 IO LVPECL pairs
// All HClock and RClock resources are utilized
// 
//
module rtax2000_cq352_SRAM (Oe, Resetn, Hclock3, Rclock3, //Hclock4,
							Ram_test_mon, rambist_test_mon);  //Ramfifo_test_mon,	

input Oe;
input Resetn; 
input Hclock3; //Hclock4;
input Rclock3;

output Ram_test_mon;
//output Ramfifo_test_mon;
output rambist_test_mon;


///////////////////////////////////  parameters, wires and registers ///////////////////
//
parameter
	  NUM_RAMBIST_BLOCKS = 1, 
	  NUM_RAM_BLOCKS = 11;//,
	  //NUM_RAMFIFO_BLOCKS = 11;
	  
/*	  NUM_LVPECL_BLOCKS = 1;*/

wire [NUM_RAMBIST_BLOCKS:1] rambist_test_ok;

wire [NUM_RAM_BLOCKS:1] Ram_test_ok;
//wire [NUM_RAMFIFO_BLOCKS:1] Ramfifo_test_ok;

wire Ram_combo_test_ok; 
//wire Ramfifo_combo_test_ok; 
wire Ram_test_mon_d; //, Ramfifo_test_mon_d;
wire rambist_test_mon_d;       
wire Resetn_buf, Rclock_buf3;


//always @(Resetn_buf or Burnin) if (Resetn_buf==1'b0) burnin_lat = Burnin;



/******************************* highz and reset sync modules ******************/

//highz UHIZ(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(Burnin), .Oe(oe));
reset_sync URES(.Clock(Rclock_buf3), .Resetn(Resetn_in), .Sresetn(sresetn));


HCLKBUF HCLK3 (.PAD(Hclock3), .Y(Hclock_buf3));
//HCLKBUF HCLK4 (.PAD(Hclock4), .Y(Hclock_buf4));
CLKBUF RCLK3 (.PAD(Rclock3), .Y(Rclock_buf3));
INBUF RSTN (.PAD(Resetn), .Y(Resetn_in));
CLKINT SRSTN (.A(sresetn), .Y(Resetn_buf));



/***************************************** RAM BIST Model ******************************************/

ramlatch_bist URAMBIST (.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Test_ok(rambist_test_ok)) /* synthesis syn_macro=1 */;

rambist_test_mon #(NUM_RAMBIST_BLOCKS, 4) URAMBIST_MON (.Clock(Rclock_buf3), .Resetn(Resetn_buf), .rambist_test_ok(rambist_test_ok), .rambist_test_mon(rambist_test_mon_d));

/**************************************** Combinatorial modules ***********************************/



/*********************************************  RAM *************************************************/

RAM_COMBO_TEST uram_combo_test(.Clock(Hclock_buf3), .Resetn(Resetn_buf), .Compare_ok_9x2048_1(Ram_test_ok[1]), .Compare_ok_1x32768_1(Ram_test_ok[2]), .Compare_ok_2x2048_1(Ram_test_ok[3]), .Compare_ok_4x1024_1(Ram_test_ok[4]), .Compare_ok_9x512_1(Ram_test_ok[5]), .Compare_ok_18x512(Ram_test_ok[6]), .Compare_ok_9x512_2(Ram_test_ok[7]), .Compare_ok_9x2048_2(Ram_test_ok[8]), .Compare_ok_1x32768_2(Ram_test_ok[9]), .Compare_ok_2x2048_2(Ram_test_ok[10]), .Compare_ok_4x1024_2(Ram_test_ok[11]), .Combo_test_ok(Ram_combo_test_ok));

test_mon #(NUM_RAM_BLOCKS, 4) URAM_MON(.Clock(Hclock_buf3), .Resetn(Resetn_buf), .test_ok(Ram_test_ok), .test_mon(Ram_test_mon_d));

/***************************************************************************************************/
/*********************************************  FIFO ***********************************************/
/***************************************************************************************************/

//FIFO_COMBO_TEST ufifo_combo_test(.Clock(Hclock_buf4), .Resetn(Resetn_buf), .Compare_ok_9x2048_1(Ramfifo_test_ok[1]), .Compare_ok_1x32768_1(Ramfifo_test_ok[2]), .Compare_ok_2x2048_1(Ramfifo_test_ok[3]), .Compare_ok_4x1024_1(Ramfifo_test_ok[4]), .Compare_ok_9x512_1(Ramfifo_test_ok[5]), .Compare_ok_18x512(Ramfifo_test_ok[6]),.Compare_ok_9x512_2(Ramfifo_test_ok[7]), .Compare_ok_9x2048_2(Ramfifo_test_ok[8]), .Compare_ok_1x32768_2(Ramfifo_test_ok[9]), .Compare_ok_2x2048_2(Ramfifo_test_ok[10]), .Compare_ok_4x1024_2(Ramfifo_test_ok[11]), .Combo_test_ok(Ramfifo_combo_test_ok));

//test_mon #(NUM_RAMFIFO_BLOCKS, 4) URAMFIFO_MON(.Clock(Hclock_buf4), .Resetn(Resetn_buf), .test_ok(Ramfifo_test_ok), .test_mon(Ramfifo_test_mon_d)); 

/***************************************  Global test monitor block ********************/


      
assign rambist_test_mon = (Oe) ? rambist_test_mon_d  : 1'bz;         
//assign Ramfifo_test_mon = (Oe) ? Ramfifo_test_mon_d  : 1'bz;      
assign Ram_test_mon = (Oe) ? Ram_test_mon_d  : 1'bz;      
  

endmodule
