// FF2048
`timescale 1 ns/100 ps

module rtax2000_cq352_FFTest (CLEARI, HCLOCKA_IN, CLOCK_IN, CLOCK_OUT, O_ANDP_CLK, O_ORP_CLK, O_ANDC_CLK, O_ORC_CLK, O_FF_CLK);


input	CLEARI;
input	HCLOCKA_IN;
input	[3:1] CLOCK_IN;
output	CLOCK_OUT; //[3:1] 
output	[4:1] O_FF_CLK;
output	[4:1] O_ANDP_CLK;
output	[4:1] O_ORP_CLK;
output	[4:1] O_ANDC_CLK;
output	[4:1] O_ORC_CLK;

wire	[4:1] RST;
wire	[4:1] Q_int;
wire	[4:1] Q_sig;
wire	[4:1] CLK_Buf;

wire	[4:1] ANDP_CLK;
wire	[4:1] ORP_CLK;
wire	[4:1] ANDC_CLK;
wire	[4:1] ORC_CLK;

assign	Q_int = Q_sig;



//FF testing


	generate
		genvar i;
			for (i = 1; i <=3; i= i+1)
				begin: FFTest
					BUFD	BUFD_RST_inst (.A(CLEARI), .Y(RST[i]));
					FF2048	FF2048_inst (Q_int[i], Q_sig[i], CLK_Buf[i], RST[i], ANDP_CLK[i], ORP_CLK[i], ANDC_CLK[i], ORC_CLK[i]);

					OUTBUF	OUTBUF_FF2048_inst1 (.D(ANDP_CLK[i]), .PAD(O_ANDP_CLK[i]));
					OUTBUF	OUTBUF_FF2048_inst2 (.D(ANDC_CLK[i]), .PAD(O_ANDC_CLK[i]));
					OUTBUF	OUTBUF_FF2048_inst3 (.D(ORP_CLK[i]), .PAD(O_ORP_CLK[i]));
					OUTBUF	OUTBUF_FF2048_inst4 (.D(ORC_CLK[i]), .PAD(O_ORC_CLK[i]));
					OUTBUF	OUTBUF_FF2048_inst5 (.D(Q_sig[i]), .PAD(O_FF_CLK[i]));

					//CLKBUF	CLKBUF_CLOCK_inst (.PAD(CLOCK_IN[i]), .Y(CLK_Buf[i]));
					//OUTBUF	OUTBUF_CLOCK_inst (.D(CLK_Buf[i]), .PAD(CLOCK_OUT[i]));		
				end
	endgenerate



	CLKBUF	CLKBUF_CLOCK_inst1 (.PAD(CLOCK_IN[1]), .Y(CLK_Buf[1]));
	OUTBUF	OUTBUF_CLOCK_inst1 (.D(CLK_Buf[1]), .PAD(CLOCK_OUT));  // [1]

	HCLKBUF	CLKBUF_CLOCK_inst2 (.PAD(CLOCK_IN[2]), .Y(CLK_Buf[2]));
	//OUTBUF	OUTBUF_CLOCK_inst2 (.D(CLK_Buf[2]), .PAD(CLOCK_OUT[2]));

	HCLKBUF	CLKBUF_CLOCK_inst3 (.PAD(CLOCK_IN[3]), .Y(CLK_Buf[3]));



	BUFD	BUFF_RST3584_inst (.A(CLEARI), .Y(RST[4]));					
	FF3584  FF3584_inst (Q_int[4], Q_sig[4], CLK_Buf[4], RST[4], ANDP_CLK[4], ORP_CLK[4], ANDC_CLK[4], ORC_CLK[4]);

	OUTBUF	OUTBUF_FF3584_inst1 (.D(ANDP_CLK[4]), .PAD(O_ANDP_CLK[4]));
	OUTBUF	OUTBUF_FF3584_inst2 (.D(ANDC_CLK[4]), .PAD(O_ANDC_CLK[4]));
	OUTBUF	OUTBUF_FF3584_inst3 (.D(ORP_CLK[4]), .PAD(O_ORP_CLK[4]));
	OUTBUF	OUTBUF_FF3584_inst4 (.D(ORC_CLK[4]), .PAD(O_ORC_CLK[4]));
	OUTBUF	OUTBUF_FF3584_inst5 (.D(Q_sig[4]), .PAD(O_FF_CLK[4]));

	HCLKBUF	HCLKBUF_CLOCK_inst4 (.PAD(HCLOCKA_IN), .Y(CLK_Buf[4]));



endmodule