`timescale 1ns/100ps
// AX2000 Burnin module definition 
// 03/04/2003
// Manish R. Babladi
// 
// Cascaded RAM and FIFOs - 64
// IO Groups - Groups of 8
// Combo Test - Token passing
// Registers/Latches - RAM BIST
// 5 IO LVPECL pairs
// All HClock and RClock resources are utilized
// 
//
module rtax2000_cq352(Hclock2, Hclock3, Hclock1, Hclock4, Rclock1, Rclock2, Rclock3, Resetn, Burnin, 
                Io_group1,  Io_group2,  Io_group3,  Io_group4, Io_group5, Io_group6,  Io_group7, Io_group8,  Io_group9,  Io_group10, Io_group11, Io_group12, Io_group13, Io_group14, Io_group15, Io_group16, Io_group17, Io_group18, Io_group19, 
/*		Io_group20, Io_group21, Io_group22, Io_group23, Io_group24, Io_group25, Io_group26, Io_group27, Io_group28, Io_group29, Io_group30, Io_group31, Io_group32, */
/*		Io_group33, Io_group34, Io_group35, Io_group36, Io_group37, Io_group38, Io_group39, Io_group40, Io_group41, Io_group42, Io_group43, Io_group44, Io_group45, Io_group46, Io_group47, */
		Global_test_mon ,
                C_test_mon, Io_test_mon, ALU_test_mon,
		Ram_test_mon, Ramfifo_test_mon,	
		rambist_test_mon,
		ctest_ok_sel, ctest_done_sel, ctest_ok, ctest_done,
		PADP_LVPECL, PADN_LVPECL, DELAY_IN_c, DELAY_OUT_c 
/*		PADP_IN, PADN_IN, LVPECL_Enable,*/
/*        LVPECL_IN_test_mon, LVPECL_IN_test_mon2*/
	)/* synthesis syn_noclockbuf = 1 */;
// 

//  declaration of inputs and ouputs 

input Resetn, Burnin;
input Hclock2, Hclock3, Hclock1, Hclock4;
input Rclock1, Rclock2, Rclock3;
input [4:0] ctest_ok_sel;
input [4:0] ctest_done_sel;
input DELAY_IN_c;
output DELAY_OUT_c;
output [1:0] PADP_LVPECL, PADN_LVPECL;
/*input [1:0] PADP_IN, PADN_IN;*/
/*input LVPECL_Enable;*/
output [8:2] ctest_ok;
output [8:2] ctest_done;

inout  [7:0] Io_group1,  Io_group2,  Io_group3,  Io_group4,  Io_group5,  Io_group6,  Io_group7,
             Io_group8,  Io_group9,  Io_group10, Io_group11, Io_group12, 
 	     Io_group13, Io_group14, Io_group15, Io_group16, Io_group17, Io_group18, Io_group19;
/*	     Io_group20, Io_group21,*/
/*             Io_group22, Io_group23, Io_group24, Io_group25, Io_group26, Io_group27, Io_group28,*/
/*	     Io_group29, Io_group30, Io_group31, Io_group32;*/
/*	     Io_group33, Io_group34, Io_group35, Io_group36, Io_group37, Io_group38,*/
/*             Io_group39, Io_group40, Io_group41, Io_group42, Io_group43, Io_group44, Io_group45,*/
/*             Io_group46, Io_group47; */

output C_test_mon; 
output Io_test_mon;
output ALU_test_mon;
output Ram_test_mon;
output Ramfifo_test_mon;
output rambist_test_mon;
output Global_test_mon
;
/*output LVPECL_IN_test_mon, LVPECL_IN_test_mon2;*/

///////////////////////////////////  parameters, wires and registers ///////////////////
//
parameter NUM_IO_BLOCKS = 19,
	  NUM_RAMBIST_BLOCKS = 1,
	  NUM_COMBO_BLOCKS = 24,
	  NUM_RAM_BLOCKS = 11,
	  NUM_RAMFIFO_BLOCKS = 11,
	  NUM_ALU_BLOCKS = 1;
/*	  NUM_LVPECL_BLOCKS = 1;*/
wire [NUM_IO_BLOCKS:1] Io_test_ok;
wire [NUM_RAMBIST_BLOCKS:1] rambist_test_ok;
wire [NUM_COMBO_BLOCKS:1]  Combinatorial_combo_test_ok;
wire [NUM_RAM_BLOCKS:1] Ram_test_ok;
wire [NUM_RAMFIFO_BLOCKS:1] Ramfifo_test_ok;
wire [NUM_ALU_BLOCKS:1] ALU_test_ok;
wire Ram_combo_test_ok; 
wire Ramfifo_combo_test_ok; 
wire ALU_test_mon_d, Ram_test_mon_d, C_test_mon_d, Io_test_mon_d, Ramfifo_test_mon_d;
wire rambist_test_mon_d;       
wire Global_test_mon_d, oe;       
wire Resetn_buf;
wire [8:2] Q1_ctest_ok_d, Q1_ctest_done_d,  
           Q2_ctest_ok_d, Q2_ctest_done_d,
		   Q3_ctest_ok_d, Q3_ctest_done_d,
	       Q4_ctest_ok_d, Q4_ctest_done_d;
wire [8:2] Q5_ctest_ok_d, Q5_ctest_done_d,  
           Q6_ctest_ok_d, Q6_ctest_done_d,
		   Q7_ctest_ok_d, Q7_ctest_done_d,
	       Q8_ctest_ok_d, Q8_ctest_done_d;
wire [8:2] Q9_ctest_ok_d, Q9_ctest_done_d,  
           Q10_ctest_ok_d, Q10_ctest_done_d,
		   Q11_ctest_ok_d, Q11_ctest_done_d,
		   Q12_ctest_ok_d, Q12_ctest_done_d;
wire [8:2] Q13_ctest_ok_d, Q13_ctest_done_d; 
wire [8:2] Q14_ctest_ok_d, Q14_ctest_done_d;
wire [8:2] Q15_ctest_ok_d, Q15_ctest_done_d;
wire [8:2] Q16_ctest_ok_d, Q16_ctest_done_d;

wire [8:2] Q17_ctest_ok_d, Q17_ctest_done_d; 
wire [8:2] Q18_ctest_ok_d, Q18_ctest_done_d;
wire [8:2] Q19_ctest_ok_d, Q19_ctest_done_d;
wire [8:2] Q20_ctest_ok_d, Q20_ctest_done_d;

wire [8:2] Q21_ctest_ok_d, Q21_ctest_done_d; 
wire [8:2] Q22_ctest_ok_d, Q22_ctest_done_d;
wire [8:2] Q23_ctest_ok_d, Q23_ctest_done_d;
wire [8:2] Q24_ctest_ok_d, Q24_ctest_done_d;
//wire [8:2] Q25_ctest_ok_d, Q25_ctest_done_d;

wire [8:2] ctest_ok_d;
wire [8:2] ctest_done_d;

/*wire LVPECL_IN_test_mon_d;*/
/*wire LVPECL_Test_ok;*/

reg burnin_lat;

always @(Resetn_buf or Burnin) if (Resetn_buf==1'b0) burnin_lat = Burnin;

/********************************************************************************/
/******************************  module instantiations **************************/
/********************************************************************************/

/*****************************  IOLVPECL Output ********************************/

iolvpecl_stimulate uiolvpecl_stimulate(.PADP(PADP_LVPECL), .PADN(PADN_LVPECL), .External_inputn(1'b1), .Resetn(Resetn_buf), .Clock(Rclock_buf1), .D_ext(2'b0));

/***************************** IOLVPECL INPUT **********************************/

/*lvpecl_in_test lvpecl_in_inst(.PADP_IN(PADP_IN), .PADN_IN(PADN_IN), .Clock(Rclock_buf1), .Resetn(Resetn_buf), .LVPECL_Enable(LVPECL_Enable), .Test_ok(LVPECL_Test_ok));*/

/*lvpecl_test_mon #(NUM_LVPECL_BLOCKS, 4) LVPECLIN_MON(.Clock(Rclock_buf1), .Resetn(Resetn_buf), .lvpecl_test_ok(LVPECL_Test_ok), .LVPECL_IN_test_mon(LVPECL_IN_test_mon_d));*/

 
/******************************* highz and reset sync modules ******************/

highz UHIZ(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(Burnin), .Oe(oe));
reset_sync URES(.Clock(Rclock_buf2), .Resetn(Resetn_in), .Sresetn(sresetn));

/*****************************  Hclock and Rclock modules ***********************/

HCLKBUF HCLK1 (.PAD(Hclock1), .Y(Hclock_buf1));
HCLKBUF HCLK2 (.PAD(Hclock2), .Y(Hclock_buf2));
HCLKBUF HCLK3 (.PAD(Hclock3), .Y(Hclock_buf3));
HCLKBUF HCLK4 (.PAD(Hclock4), .Y(Hclock_buf4));

CLKBUF RCLK1 (.PAD(Rclock1), .Y(Rclock_buf1));
CLKBUF RCLK2 (.PAD(Rclock2), .Y(Rclock_buf2));
CLKBUF RCLK3 (.PAD(Rclock3), .Y(Rclock_buf3));
/*BUFD RCLKBUFD3(.A(Rclock_buf2),.Y(n_Rclock_buf3));*/
/*CLKINT RCLK3(.A(n_Rclock_buf3), .Y(Rclock_buf3));*/
/*CLKINT RCLK4(.A(n_Rclock_buf3), .Y(Rclock_buf4));*/

INBUF RSTN (.PAD(Resetn), .Y(Resetn_in));
CLKINT SRSTN (.A(sresetn), .Y(Resetn_buf));

/****************************************** IO Group ***********************************************/ 
   
/*io_test #(8,8) UIO_47(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[47]),.Io_pad(Io_group47)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_46(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[46]),.Io_pad(Io_group46)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_45(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[45]),.Io_pad(Io_group45)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_44(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[44]),.Io_pad(Io_group44)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_43(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[43]),.Io_pad(Io_group43)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_42(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[42]),.Io_pad(Io_group42)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_41(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[41]),.Io_pad(Io_group41)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_40(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[40]),.Io_pad(Io_group40)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_39(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[39]),.Io_pad(Io_group39)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_38(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[38]),.Io_pad(Io_group38)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_37(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[37]),.Io_pad(Io_group37)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_36(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[36]),.Io_pad(Io_group36)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_35(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[35]),.Io_pad(Io_group35)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_34(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[34]),.Io_pad(Io_group34)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_33(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[33]),.Io_pad(Io_group33)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_32(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[32]),.Io_pad(Io_group32)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_31(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[31]),.Io_pad(Io_group31)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_30(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[30]),.Io_pad(Io_group30)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_29(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[29]),.Io_pad(Io_group29)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_28(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[28]),.Io_pad(Io_group28)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_27(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[27]),.Io_pad(Io_group27)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_26(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[26]),.Io_pad(Io_group26)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_25(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[25]),.Io_pad(Io_group25)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_24(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[24]),.Io_pad(Io_group24)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_23(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[23]),.Io_pad(Io_group23)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_22(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[22]),.Io_pad(Io_group22)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_21(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[21]),.Io_pad(Io_group21)) |+ synthesis syn_noprune = 1 +|;*/
/*io_test #(8,8) UIO_20(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[20]),.Io_pad(Io_group20)) |+ synthesis syn_noprune = 1 +|;*/
io_test #(8,8) UIO_19(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[19]),.Io_pad(Io_group19)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_18(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[18]),.Io_pad(Io_group18)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_17(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[17]),.Io_pad(Io_group17)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_16(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[16]),.Io_pad(Io_group16)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_15(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[15]),.Io_pad(Io_group15)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_14(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[14]),.Io_pad(Io_group14)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_13(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[13]),.Io_pad(Io_group13)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_12(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[12]),.Io_pad(Io_group12)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_11(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[11]),.Io_pad(Io_group11)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_10(.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[10]),.Io_pad(Io_group10)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_9 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[9]), .Io_pad(Io_group9)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_8 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[8]), .Io_pad(Io_group8)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_7 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[7]), .Io_pad(Io_group7)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_6 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[6]), .Io_pad(Io_group6)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_5 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[5]), .Io_pad(Io_group5)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_4 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[4]), .Io_pad(Io_group4)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_3 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[3]), .Io_pad(Io_group3)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_2 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[2]), .Io_pad(Io_group2)) /* synthesis syn_noprune = 1 */;
io_test #(8,8) UIO_1 (.Clock(Hclock_buf2),.Resetn(Resetn_buf),.Oe(oe),.Test_ok(Io_test_ok[1]), .Io_pad(Io_group1)) /* synthesis syn_noprune = 1 */;

io_test_mon #(NUM_IO_BLOCKS, 4) UIO_MON (.Clock(Hclock_buf2), .Resetn(Resetn_buf), .Io_test_ok(Io_test_ok), .Io_test_mon(Io_test_mon_d));


/***************************************** RAM BIST Model ******************************************/

ramlatch_bist URAMBIST (.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Test_ok(rambist_test_ok)) /* synthesis syn_macro=1 */;

rambist_test_mon #(NUM_RAMBIST_BLOCKS, 4) URAMBIST_MON (.Clock(Rclock_buf3), .Resetn(Resetn_buf), .rambist_test_ok(rambist_test_ok), .rambist_test_mon(rambist_test_mon_d));

/**************************************** Combinatorial modules ***********************************/

combo_bist_1 UCOMBO_Q1(.Clock(Rclock_buf1), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q1_debug_sel), .Test_ok(Q1_ctest_ok_d),.Test_out(Q1_ctest_done_d),.Data_out(Q1_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[1])) /* synthesis syn_noprune = 1 */;
combo_bist_2 UCOMBO_Q2(.Clock(Rclock_buf1), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q2_debug_sel), .Test_ok(Q2_ctest_ok_d),.Test_out(Q2_ctest_done_d),.Data_out(Q2_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[2])) /* synthesis syn_noprune = 1 */;
combo_bist_3 UCOMBO_Q3(.Clock(Rclock_buf1), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q3_debug_sel), .Test_ok(Q3_ctest_ok_d),.Test_out(Q3_ctest_done_d),.Data_out(Q3_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[3])) /* synthesis syn_noprune = 1 */;
combo_bist_4 UCOMBO_Q4(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q4_debug_sel), .Test_ok(Q4_ctest_ok_d),.Test_out(Q4_ctest_done_d),.Data_out(Q4_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[4])) /* synthesis syn_noprune = 1 */;
combo_bist_1 UCOMBO_Q5(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q5_debug_sel), .Test_ok(Q5_ctest_ok_d),.Test_out(Q5_ctest_done_d),.Data_out(Q5_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[5])) /* synthesis syn_noprune = 1 */;
combo_bist_2 UCOMBO_Q6(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q6_debug_sel), .Test_ok(Q6_ctest_ok_d),.Test_out(Q6_ctest_done_d),.Data_out(Q6_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[6])) /* synthesis syn_noprune = 1 */;
combo_bist_3 UCOMBO_Q7(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q7_debug_sel), .Test_ok(Q7_ctest_ok_d),.Test_out(Q7_ctest_done_d),.Data_out(Q7_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[7])) /* synthesis syn_noprune = 1 */;
combo_bist_4 UCOMBO_Q8(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q8_debug_sel), .Test_ok(Q8_ctest_ok_d),.Test_out(Q8_ctest_done_d),.Data_out(Q8_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[8])) /* synthesis syn_noprune = 1 */;
combo_bist_1 UCOMBO_Q9(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q9_debug_sel), .Test_ok(Q9_ctest_ok_d),.Test_out(Q9_ctest_done_d),.Data_out(Q9_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[9])) /* synthesis syn_noprune = 1 */;

combo_bist_2 UCOMBO_Q10(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q10_debug_sel), .Test_ok(Q10_ctest_ok_d),.Test_out(Q10_ctest_done_d),.Data_out(Q10_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[10])) /* synthesis syn_noprune = 1 */;
combo_bist_3 UCOMBO_Q11(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q11_debug_sel), .Test_ok(Q11_ctest_ok_d),.Test_out(Q11_ctest_done_d),.Data_out(Q11_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[11])) /* synthesis syn_noprune = 1 */;
combo_bist_4 UCOMBO_Q12(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q12_debug_sel), .Test_ok(Q12_ctest_ok_d),.Test_out(Q12_ctest_done_d),.Data_out(Q12_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[12] )) /* synthesis syn_noprune = 1 */;

combo_bist_1 UCOMBO_Q13(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q13_debug_sel), .Test_ok(Q13_ctest_ok_d),.Test_out(Q13_ctest_done_d),.Data_out(Q13_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[13])) /* synthesis syn_noprune = 1 */;
combo_bist_2 UCOMBO_Q14(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q14_debug_sel), .Test_ok(Q14_ctest_ok_d),.Test_out(Q14_ctest_done_d),.Data_out(Q14_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[14])) /* synthesis syn_noprune = 1 */;
combo_bist_3 UCOMBO_Q15(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q15_debug_sel), .Test_ok(Q15_ctest_ok_d),.Test_out(Q15_ctest_done_d),.Data_out(Q15_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[15])) /* synthesis syn_noprune = 1 */;
combo_bist_4 UCOMBO_Q16(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q16_debug_sel), .Test_ok(Q16_ctest_ok_d),.Test_out(Q16_ctest_done_d),.Data_out(Q16_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[16] )) /* synthesis syn_noprune = 1 */;

combo_bist_1 UCOMBO_Q17(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q17_debug_sel), .Test_ok(Q17_ctest_ok_d),.Test_out(Q17_ctest_done_d),.Data_out(Q17_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[17])) /* synthesis syn_noprune = 1 */;
combo_bist_2 UCOMBO_Q18(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q18_debug_sel), .Test_ok(Q18_ctest_ok_d),.Test_out(Q18_ctest_done_d),.Data_out(Q18_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[18])) /* synthesis syn_noprune = 1 */;
combo_bist_3 UCOMBO_Q19(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q19_debug_sel), .Test_ok(Q19_ctest_ok_d),.Test_out(Q19_ctest_done_d),.Data_out(Q19_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[19])) /* synthesis syn_noprune = 1 */;
combo_bist_4 UCOMBO_Q20(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q20_debug_sel), .Test_ok(Q20_ctest_ok_d),.Test_out(Q20_ctest_done_d),.Data_out(Q20_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[20] )) /* synthesis syn_noprune = 1 */;

combo_bist_1 UCOMBO_Q21(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q21_debug_sel), .Test_ok(Q21_ctest_ok_d),.Test_out(Q21_ctest_done_d),.Data_out(Q21_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[21])) /* synthesis syn_noprune = 1 */;
combo_bist_2 UCOMBO_Q22(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q22_debug_sel), .Test_ok(Q22_ctest_ok_d),.Test_out(Q22_ctest_done_d),.Data_out(Q22_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[22])) /* synthesis syn_noprune = 1 */;
combo_bist_3 UCOMBO_Q23(.Clock(Rclock_buf2), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q23_debug_sel), .Test_ok(Q23_ctest_ok_d),.Test_out(Q23_ctest_done_d),.Data_out(Q23_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[23])) /* synthesis syn_noprune = 1 */;
combo_bist_4 UCOMBO_Q24(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q24_debug_sel), .Test_ok(Q24_ctest_ok_d),.Test_out(Q24_ctest_done_d),.Data_out(Q24_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[24] )) /* synthesis syn_noprune = 1 */;
//combo_bist_4 UCOMBO_Q25(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Burnin(burnin_lat), .Debug_sel(Q25_debug_sel), .Test_ok(Q25_ctest_ok_d),.Test_out(Q25_ctest_done_d),.Data_out(Q25_ctest_debug_d),.Combo_test_ok(Combinatorial_combo_test_ok[25] )) /* synthesis syn_noprune = 1 */;

combo_test_mon #(NUM_COMBO_BLOCKS, 4) UCOMBO_MON(.Clock(Rclock_buf3), .Resetn(Resetn_buf), .Combo_test_ok(Combinatorial_combo_test_ok), .Combo_test_mon(C_test_mon_d));
//
/*********************************************  ALU *************************************************/

alu_bist ualu_bist(.Clock(Hclock_buf1), .Resetn(Resetn_buf), .Test_ok(ALU_test_ok[1]), .alu_out(alu_out_d));

test_mon #(NUM_ALU_BLOCKS, 4) UALU_MON(.Clock(Hclock_buf1), .Resetn(Resetn_buf), .test_ok(ALU_test_ok), .test_mon(ALU_test_mon_d));
// 

/*********************************************  RAM *************************************************/

RAM_COMBO_TEST uram_combo_test(.Clock(Hclock_buf3), .Resetn(Resetn_buf), .Compare_ok_9x2048_1(Ram_test_ok[1]), .Compare_ok_1x32768_1(Ram_test_ok[2]), .Compare_ok_2x2048_1(Ram_test_ok[3]), .Compare_ok_4x1024_1(Ram_test_ok[4]), .Compare_ok_9x512_1(Ram_test_ok[5]), .Compare_ok_18x512(Ram_test_ok[6]), .Compare_ok_9x512_2(Ram_test_ok[7]), .Compare_ok_9x2048_2(Ram_test_ok[8]), .Compare_ok_1x32768_2(Ram_test_ok[9]), .Compare_ok_2x2048_2(Ram_test_ok[10]), .Compare_ok_4x1024_2(Ram_test_ok[11]), .Combo_test_ok(Ram_combo_test_ok));

test_mon #(NUM_RAM_BLOCKS, 4) URAM_MON(.Clock(Hclock_buf3), .Resetn(Resetn_buf), .test_ok(Ram_test_ok), .test_mon(Ram_test_mon_d));

/***************************************************************************************************/
/*********************************************  FIFO ***********************************************/
/***************************************************************************************************/

FIFO_COMBO_TEST ufifo_combo_test(.Clock(Hclock_buf4), .Resetn(Resetn_buf), .Compare_ok_9x2048_1(Ramfifo_test_ok[1]), .Compare_ok_1x32768_1(Ramfifo_test_ok[2]), .Compare_ok_2x2048_1(Ramfifo_test_ok[3]), .Compare_ok_4x1024_1(Ramfifo_test_ok[4]), .Compare_ok_9x512_1(Ramfifo_test_ok[5]), .Compare_ok_18x512(Ramfifo_test_ok[6]),.Compare_ok_9x512_2(Ramfifo_test_ok[7]), .Compare_ok_9x2048_2(Ramfifo_test_ok[8]), .Compare_ok_1x32768_2(Ramfifo_test_ok[9]), .Compare_ok_2x2048_2(Ramfifo_test_ok[10]), .Compare_ok_4x1024_2(Ramfifo_test_ok[11]), .Combo_test_ok(Ramfifo_combo_test_ok));

test_mon #(NUM_RAMFIFO_BLOCKS, 4) URAMFIFO_MON(.Clock(Hclock_buf4), .Resetn(Resetn_buf), .test_ok(Ramfifo_test_ok), .test_mon(Ramfifo_test_mon_d)); 

/***************************************  Global test monitor block ********************/

test_mon #(NUM_IO_BLOCKS +   NUM_RAMBIST_BLOCKS  + NUM_COMBO_BLOCKS + NUM_RAM_BLOCKS  + NUM_RAMFIFO_BLOCKS + NUM_ALU_BLOCKS, 4) utest_mon(.Clock(Rclock_buf1), .Resetn(Resetn_buf), .test_ok({Ram_test_ok, Ramfifo_test_ok, ALU_test_ok, Combinatorial_combo_test_ok, rambist_test_ok, Io_test_ok}), .test_mon(Global_test_mon_d));

//////////////////  mux instantiation /////////////////////////////////////////
//  used to select between test ok and test done signals
//  
mux7x24 umux7x24(.Data0(Q1_ctest_ok_d), .Data1(Q2_ctest_ok_d), .Data2(Q3_ctest_ok_d), .Data3(Q4_ctest_ok_d), .Data4(Q5_ctest_ok_d), .Data5(Q6_ctest_ok_d), .Data6(Q7_ctest_ok_d), .Data7(Q8_ctest_ok_d), .Data8(Q9_ctest_ok_d), .Data9(Q10_ctest_ok_d), .Data10(Q11_ctest_ok_d), .Data11(Q12_ctest_ok_d), .Data12(Q13_ctest_ok_d), .Data13(Q14_ctest_ok_d), .Data14(Q15_ctest_ok_d), .Data15(Q16_ctest_ok_d),.Data16(Q17_ctest_ok_d),.Data17(Q18_ctest_ok_d),.Data18(Q19_ctest_ok_d),.Data19(Q20_ctest_ok_d),.Data20(Q21_ctest_ok_d),.Data21(Q22_ctest_ok_d),.Data22(Q23_ctest_ok_d), .Data23(Q24_ctest_ok_d), .Sel(ctest_ok_sel), .Result(ctest_ok_d));

mux7x24 umux7x24_2(.Data0(Q1_ctest_done_d), .Data1(Q2_ctest_done_d), .Data2(Q3_ctest_done_d), .Data3(Q4_ctest_done_d), .Data4(Q5_ctest_done_d), .Data5(Q6_ctest_done_d), .Data6(Q7_ctest_done_d), .Data7(Q8_ctest_done_d), .Data8(Q9_ctest_done_d), .Data9(Q10_ctest_done_d), .Data10(Q11_ctest_done_d), .Data11(Q12_ctest_done_d), .Data12(Q13_ctest_done_d), .Data13(Q14_ctest_done_d), .Data14(Q15_ctest_done_d), .Data15(Q16_ctest_done_d),.Data16(Q17_ctest_done_d),.Data17(Q18_ctest_done_d),.Data18(Q19_ctest_done_d),.Data19(Q20_ctest_done_d), .Data20(Q21_ctest_done_d),.Data21(Q22_ctest_done_d),.Data22(Q23_ctest_done_d),.Data23(Q24_ctest_done_d),.Sel(ctest_done_sel), .Result(ctest_done_d));


DELAY_PATH_SHORT UDELAY(.DELAY_IN(DELAY_IN_c), .DELAY_OUT(DELAY_OUT_c));

////////////////////  assign statements so that oe can be used to tristate ios ////

assign ctest_ok = (oe) ? ctest_ok_d : 7'bzzzzzzz;
assign ctest_done = (oe) ? ctest_done_d : 7'bzzzzzzz;
assign Global_test_mon = (oe) ? Global_test_mon_d     : 1'bz;      
assign C_test_mon = (oe) ? C_test_mon_d     : 1'bz;
assign Io_test_mon = (oe) ? Io_test_mon_d    : 1'bz;      
assign rambist_test_mon = (oe) ? rambist_test_mon_d  : 1'bz;         
assign Ramfifo_test_mon = (oe) ? Ramfifo_test_mon_d  : 1'bz;      
assign Ram_test_mon = (oe) ? Ram_test_mon_d  : 1'bz;      
assign ALU_test_mon = (oe) ? ALU_test_mon_d  : 1'bz;  

endmodule
