//timescale 1ns/100ps
// AX2000 Burnin module definition 
// 03/04/2003
// Manish R. Babladi
// 
// Cascaded RAM and FIFOs - 64
// IO Groups - Groups of 8
// Combo Test - Token passing
// Registers/Latches - RAM BIST
// 5 IO LVPECL pairs
// All HClock and RClock resources are utilized
// 
//
module rtax2000_cq352_Top (Oe, RCLK3P, HCLK1P, HCLK2P, RCLK4P, Ram_test_mon, rambist_test_mon, //Hclock4,//Ramfifo_test_mon,	 
                           LOADIN, I_BS, O_BS, DIO_IP, DIO_IN, DIO_O, IO_I, IO_O, DA, QA, EN8, YQ, Bi_D, Bi_E, Bi_Y, Bi_IO,
						   RCLK1P, RCLK2P, HCLK3P, HCLK4P, CLOCKE_OUT, CLOCKF_OUT, //CLOCKG_OUT, CLOCKH_OUT,
						   O_ANDP_CLKF, O_ANDP_CLKG, O_ANDP_CLKH, O_ANDP_HCLKA,
						   O_ANDC_CLKF, O_ANDC_CLKG, O_ANDC_CLKH, O_ANDC_HCLKA,
						   O_ORP_CLKF, O_ORP_CLKG, O_ORP_CLKH, O_ORP_HCLKA,
						   O_ORC_CLKF, O_ORC_CLKG, O_ORC_CLKH, O_ORC_HCLKA,
						   O_FF_CLKF, O_FF_CLKG, O_FF_CLKH, O_FF_HCLKA);


input 	Oe;
input 	RCLK3P; 
input 	HCLK2P;
input 	RCLK4P;

output 	Ram_test_mon;
output 	rambist_test_mon;
//output 	Ramfifo_test_mon;


//Buffers
output 	I_BS;
output 	O_BS;


//IOs
input 	[7:1] DIO_IP;
input 	[7:1] DIO_IN;
output 	[7:1] DIO_O;
input 	[7:1] Bi_D;
input 	[7:1] Bi_E;
output 	[7:1] Bi_Y;
inout 	[7:1] Bi_IO;
input  	[6:1] IO_I;
output 	[6:1] IO_O;
input  	DA, EN8;
output 	[2:0] QA;
output 	[7:0] YQ;


// Resert
input	LOADIN;

//Clk
input 	HCLK1P;
input	RCLK1P, RCLK2P, HCLK3P, HCLK4P; //CLOCKG_IN, CLOCKH_IN;
output	CLOCKE_OUT, CLOCKF_OUT; //, CLOCKG_OUT, CLOCKH_OUT;

//FF Test
output O_ANDP_CLKF, O_ANDP_CLKG, O_ANDP_CLKH, O_ANDP_HCLKA;
output O_ANDC_CLKF, O_ANDC_CLKG, O_ANDC_CLKH, O_ANDC_HCLKA;
output O_ORP_CLKF, O_ORP_CLKG, O_ORP_CLKH, O_ORP_HCLKA;
output O_ORC_CLKF, O_ORC_CLKG, O_ORC_CLKH, O_ORC_HCLKA;
output O_FF_CLKF, O_FF_CLKG, O_FF_CLKH, O_FF_HCLKA;	


//FF Test
wire	[4:1] O_FF_CLK;
wire	[4:1] O_ANDP_CLK;
wire	[4:1] O_ORP_CLK;
wire	[4:1] O_ANDC_CLK;
wire	[4:1] O_ORC_CLK;

// Clk
wire	[4:1] CLOCK_IN;
wire	[4:1] CLOCK_OUT;

wire	CLEARI;
wire	QI;

///////////////////////////////////  parameters, wires and registers ///////////////////

//Routed Clocks
	assign CLOCK_IN [1] = RCLK2P;
	assign CLOCK_IN [2] = HCLK3P; //CLOCKG_IN;
	assign CLOCK_IN [3] = HCLK4P; //CLOCKH_IN;
	assign CLOCK_IN [4] = RCLK1P;
//

	assign CLOCKF_OUT 	= CLOCK_OUT [1];
	//assign CLOCKG_OUT 	= CLOCK_OUT [2];
	//assign CLOCKH_OUT 	= CLOCK_OUT [3];
	assign CLOCKE_OUT 	= CLOCK_OUT [4];

	assign O_ANDP_CLKF  = O_ANDP_CLK [1]; 
	assign O_ANDP_CLKG  = O_ANDP_CLK [2]; 
	assign O_ANDP_CLKH  = O_ANDP_CLK [3]; 
	assign O_ANDP_HCLKA = O_ANDP_CLK [4];
						                 
	assign O_ANDC_CLKF  = O_ANDC_CLK [1]; 
	assign O_ANDC_CLKG  = O_ANDC_CLK [2]; 
	assign O_ANDC_CLKH  = O_ANDC_CLK [3]; 
	assign O_ANDC_HCLKA = O_ANDC_CLK [4];

	assign O_ORP_CLKF   = O_ORP_CLK [1];
	assign O_ORP_CLKG   = O_ORP_CLK [2];
	assign O_ORP_CLKH   = O_ORP_CLK [3];
	assign O_ORP_HCLKA  = O_ORP_CLK [4];
					                   
	assign O_ORC_CLKF   = O_ORC_CLK [1];
	assign O_ORC_CLKG   = O_ORC_CLK [2];
	assign O_ORC_CLKH   = O_ORC_CLK [3];
	assign O_ORC_HCLKA  = O_ORC_CLK [4];

	assign O_FF_CLKF   = O_FF_CLK [1];
	assign O_FF_CLKG   = O_FF_CLK [2];
	assign O_FF_CLKH   = O_FF_CLK [3];
	assign O_FF_HCLKA  = O_FF_CLK [4];

	assign I_BS  = QI;

	/// Instances

	rtax2000_cq352_SRAM rtax2000_cq352_SRAM_inst (.Oe(Oe),.Resetn(RCLK3P),.Hclock3 (HCLK2P),.Rclock3(RCLK4P),.Ram_test_mon(Ram_test_mon),.rambist_test_mon(rambist_test_mon)); //Ramfifo_test_mon, Hclock4, 
	
	rtax2000_cq352_FFTest rtax2000_cq352_FFTest_inst (.CLEARI(CLEARI), .HCLOCKA_IN(HCLK1P), .CLOCK_IN(CLOCK_IN[3:1]), .CLOCK_OUT(CLOCK_OUT[1]), 
													  .O_ANDP_CLK(O_ANDP_CLK),.O_ORP_CLK(O_ORP_CLK), .O_ANDC_CLK(O_ANDC_CLK), .O_ORC_CLK(O_ORC_CLK),
													  .O_FF_CLK(O_FF_CLK));	
//CLOCK_OUT[3:1]

	rtax2000_cq352_Buff10k rtax2000_cq352_Buff10k_inst (.In(QI), .Out(O_BS));
	
	rtax2000_cq352_IOs rtax2000_cq352_IOs_inst (.DIO_IP(DIO_IP), .DIO_IN(DIO_IN), .DIO_O(DIO_O), .IO_I(IO_I), .IO_O(IO_O), .DA(DA), .QA(QA), .EN8(EN8), .YQ(YQ),
												.Bi_D(Bi_D), .Bi_E(Bi_E), .Bi_Y(Bi_Y), .Bi_IO(Bi_IO));


	rtax2000_cq352_Reset_Insig rtax2000_cq352_Reset_Insig_inst (.CLOCK_IN(CLOCK_IN[4]), .LOADIN(LOADIN), .CLOCK_OUT(CLOCK_OUT[4]), .CLEARI(CLEARI), .QI(QI));


	
endmodule
