`timescale 1ns/100ps
module test_mon(Clock, Resetn, test_ok, test_mon)/*synthesis syn_hier = "hard" */;
parameter NUM = 2,
          WIDTH = 4;
input Clock, Resetn;
input [NUM:1] test_ok;
output test_mon;
wire mon_enable;
reg [WIDTH-1:0] mon;
reg fail_flag;
//
// Use the reduction AND on the test_ok inputs 
//  As long as all of the "ok" outputs are 1'b1 then the divider is enabled
//  and the monitor signal is output, should any of the "ok" outputs go low
//  then the mon signal will go to 1
//
assign mon_enable = &test_ok;

always @(posedge Clock or negedge Resetn)
 if (Resetn==1'b0)
 begin
  fail_flag <= 1'b0;
  mon <= 0;
 end
 else
  if (mon_enable && (!fail_flag)) 
   mon <= mon + 1;
  else 
   begin
   mon <= -1; // All ones 
   fail_flag <= 1'b1; 
   end

//johnson_counter #(WIDTH) UMON(.clk(Clock), .aclr(Resetn), .ena(fifo_mon_enable), .johnson_code(fifo_mon));

assign test_mon = mon[WIDTH-1];

endmodule
