`timescale 1ns/100ps 
module toggle (clk, aclr, ena, toggle);
 parameter SIZE = 4;
 parameter INIT = 0;
 input clk, aclr, ena;
 output [SIZE-1:0] toggle;

 reg [SIZE-1:0] tog;
/***************************************
 * The SX_ARCH variable is used because
 * prior to the SX_ARCH the pre-set FF
 * synplicity maps preset FF to a 
 * DFP1 CC Flip flop.  To avoid this 
 * the code is written for reset only 
 * registers and the outputs are 
 * selectively inverted.
 **************************************/
 always @(posedge clk or negedge aclr) 
  if (aclr==1'b0) 
   `ifdef SX_ARCH 
     tog <= INIT;
   `else
     tog <= 0;
   `endif
  else if (ena==1'b1) tog <= ~tog;

`ifdef SX_ARCH 
 assign toggle = tog;
`else
 assign toggle = tog ^ INIT;
`endif
endmodule
